#include maps\mp\gametypes\global\_global;

init()
{
	addEventListener("onSpawnedPlayer", ::onSpawnedPlayer);

	if (!level.spectatingSystem)
		return;

	level.autoSpectating_kills = [];

	if (!isDefined(game["autoSpectator_autoKillCam_lastTime"]))
		game["autoSpectator_autoKillCam_lastTime"] = 0;

	addEventListener("onConnected",  ::onConnected);
	addEventListener("onPlayerKilled",  ::onPlayerKilled);
        addEventListener("onMenuResponse",  ::onMenuResponse);
}

onConnected()
{
	self.autoSpectating_killIndexes = [];

	if (!level.in_readyup)
	{
		spectMenuSetRows(); // set No record to play!
	}
}

onSpawnedPlayer()
{
	// We have to make sure that this cvar is defined, otherwise quickmessages menu will not work
	self setClientCvar2("ui_quickmessage_spectatormode", "0");
}


onPlayerKilled(eInflictor, eAttacker, iDamage, sMeansOfDeath, sWeapon, vDir, sHitLoc, timeOffset, deathAnimDuration)
{
	save = (level.gametype == "sd" && level.roundstarted && !level.roundended) || (level.gametype != "sd" && level.matchstarted && !level.mapended);

	if (isDefined(eAttacker) && isPlayer(eAttacker) && eAttacker != self && save)
	{
		killRecord = spawnstruct();
		killRecord.player = eAttacker;
		killRecord.time = gettime();
		killRecord.timeFirst = killRecord.time;
		killRecord.kills = 1;
		killRecord.fullyFollowedBySpectator = isDefined(level.autoSpectating_spectatedPlayer) && eAttacker == level.autoSpectating_spectatedPlayer;
		killRecord.followedKillsBySpectator = killRecord.fullyFollowedBySpectator * 1; // how many kills were watched by spectator
		killRecord.nozoom = (eAttacker playerAds() == 0) && (distance(eAttacker.origin, self.origin) > 800);
		killRecord.bombPlanted = (level.gametype == "sd" && level.bombplanted);
		killRecord.deleted = false;

		for (i = level.autoSpectating_kills.size-1; i >= 0; i--)
		{
			lastRecord = level.autoSpectating_kills[i];

			if (lastRecord.deleted) continue;

			timeAgo = gettime() - lastRecord.time;

			if (timeAgo > 6000) break; // look only for records in last 6 sec

			// Find record with the same guy
			if (isDefined(lastRecord.player) && lastRecord.player == eAttacker)
			{
				killRecord.fullyFollowedBySpectator = killRecord.fullyFollowedBySpectator && level.autoSpectating_kills[i].fullyFollowedBySpectator;
				killRecord.followedKillsBySpectator += level.autoSpectating_kills[i].followedKillsBySpectator;
				killRecord.nozoom = killRecord.nozoom || level.autoSpectating_kills[i].nozoom;
				killRecord.timeFirst = level.autoSpectating_kills[i].timeFirst;
				killRecord.kills += level.autoSpectating_kills[i].kills;

				level.autoSpectating_kills[i].deleted = true;

				break;
			}
		}

		// Add new
		id = level.autoSpectating_kills.size;
		level.autoSpectating_kills[level.autoSpectating_kills.size] = killRecord;

		// Play auto killcam
		if ((killRecord.kills >= 2 || killRecord.nozoom) && !killRecord.fullyFollowedBySpectator)
		{
			killRecord thread potencialAutoKillcam(id);

			//eAttacker iprintln("^4This kill added for auto-killcam"); // TODO
		}
	}
}

potencialAutoKillcam(killId)
{
	// Wait untill this player does not see enemy no more - then we can replay killcam
	// If player kills another enemy, this record is deleted, this thread ends and new thread is created
	time_killer_no_enemy = 0;
	time_spectated_no_enemy = 0;
	for(;;)
	{
		if (self.deleted || !isDefined(self.player))
			return;

		// Atleast 5 seconds between killcams
		if (game["autoSpectator_autoKillCam_lastTime"] > 0 && (gettime() - game["autoSpectator_autoKillCam_lastTime"]) < 5000)
		{
			//iprintln("^4Pause between killcams"); // TODO
			wait level.fps_multiplier * .5;
			continue;
		}

		// Killer does not see more enemy for 3 seconds (action is finished)
		if (!isDefined(self.player.autospectator_visibleEnemy))
			time_killer_no_enemy += 0.05;
		else
			time_killer_no_enemy = 0;

		// Spectated player does not see enemy for 3 seconds (to avoid switch before some interesting action)
		if (!isDefined(level.autoSpectating_spectatedPlayer) || !isDefined(level.autoSpectating_spectatedPlayer.autospectator_visibleEnemy))
			time_spectated_no_enemy += 0.05;
		else
			time_spectated_no_enemy = 0;

		if (time_killer_no_enemy >= 3 && time_spectated_no_enemy >= 3)
			break;

		wait level.fps_multiplier * 0.05;
	}

	// Time when last killcam ends
	game["autoSpectator_autoKillCam_lastTime"] = gettime() + (self.time - self.timeFirst) + 4000;

	// Replay action for all spectators
	players = getentarray("player", "classname");
	for(i = 0; i < players.size; i++)
	{
		player = players[i];
		if (player.pers["team"] == "spectator" && player.pers["autoSpectating"])
		{
			player thread replayAction(killId, false);
		}
	}

}


/*
Called when command scriptmenuresponse is executed on client side
self is player that called scriptmenuresponse
Return true to indicate that menu response was handled in this function
*/
onMenuResponse(menu, response)
{
	if (menu == game["menu_spectatingsystem"])
	{
		i = -1;
    		switch(response)
		{
			case "killcam_1": i = 0; break;
			case "killcam_2": i = 1; break;
			case "killcam_3": i = 2; break;
			case "killcam_4": i = 3; break;
			case "killcam_5": i = 4; break;
			case "killcam_6": i = 5; break;
			case "killcam_7": i = 6; break;
			case "killcam_8": i = 7; break;
			case "killcam_9": i = 8; break;
			case "killcam_0": i = 9; break;
		}

		if (i > -1 && i < self.autoSpectating_killIndexes.size)
			replayAction(self.autoSpectating_killIndexes[i], true);
		else
			self iprintln("^1Not existing record");

		return true;
	}
}

openSpectMenu()
{
	self endon("disconnect");

	spectatorclient = self.spectatorclient;
	origin = self getOrigin();
	angles = self getPlayerAngles();
	self.sessionteam = "none";
	self.sessionstate = "dead"; // enable quickmessage
	self.spectatorclient = -1;
	self spawn((-99999, -99999, -99999), (0,0,0));

	self setClientCvar2("ui_quickmessage_spectatormode", "1");

	spectMenuSetRows();

	// Exec command on client side
	// If some menu is already opened:
	//	- by player (by ESC command) -> it will work well over already opened menu
	//  - by script (via openMenu()) -> that menu will be closed and exec_cmd will not be closed correctly
	//			(mouse will be visible with clear backgorund.... so closeMenu() is called to close that menu)
	self setClientCvar2("exec_cmd", "mp_quickmessage");
	self openMenu(game["menu_exec_cmd"]);		// open menu via script
	self closeMenu();							// will only close menu opened by script

	wait level.frame * 2;

	self.sessionteam = "spectator";
	self.sessionstate = "spectator";
	if (self.spectatorclient == -1)
		self.spectatorclient = spectatorclient;

	wait level.frame;

	self spawn(origin, angles);
}

spectMenuSetRows()
{
	self.autoSpectating_killIndexes = [];

	str = "";
	row = 0;
	for (i = level.autoSpectating_kills.size-1; i >= 0; i--)
	{
		record = level.autoSpectating_kills[i];

		if (record.deleted) continue;
		if (!isDefined(record.player)) continue;
		if ((gettime() - record.time) > 37000) continue; // 40 seconds is a maximum that killcam can replay

		self.autoSpectating_killIndexes[row] = i;

		str += (row+1) + ".   " + getTimeString(record.time, record.bombPlanted) + "  " + record.player.name + "^7   ("+record.kills+" kill)\n";
		row++;
	}

	if (str == "")
		self setClientCvar2("ui_spectatorsystem_menu_text", "No record to play!");
	else
		self setClientCvar2("ui_spectatorsystem_menu_text", str);
}


getTimeString(time, bombPlanted)
{
	if (level.gametype == "sd")
	{
		if (bombplanted)
			return "B " + formatTime(int(level.bombtimer - int((time - level.bombtimerstart)/1000)));
		else
			return formatTime(level.strat_time + int((level.roundlength * 60) - int((time - level.starttime)/1000)));
	}
	else
		return formatTime(int((level.timelimit * 60) - (int((time - level.starttime)/1000)) - level.timeout_elapsedTime));
}


replayAction(killId, print)
{
	self endon("disconnect");

	// Already in killcam, wait for end
	while(isDefined(self.killcam))
		wait level.fps_multiplier * 1;

	record = level.autoSpectating_kills[killId];

	if (!isDefined(record.player))
	{
		if (print || level.debug_spectator) self iprintln("^1Selected player disconnects!");
		return;
	}

	if ((gettime() - record.timeFirst) > 40000)
	{
		if (print || level.debug_spectator) self iprintln("^1Record is too old and can not be replayed");

		return;
	}

	self iprintln("Playing killcam for: " + record.player.name);

	timeBeforeKill = 2.5;
	timeAfterKill = 1.5;

	// Time between kills (0 if is single kill)
	actionTime = 0;
	if (record.time > record.timeFirst)
		actionTime = int((record.time - record.timeFirst)/1000);

	pastTime = timeBeforeKill + int((gettime() - record.timeFirst) / 1000);

	self maps\mp\gametypes\_killcam::killcam(record.player getEntityNumber(), pastTime, (timeBeforeKill + actionTime + timeAfterKill), 0, false, true); // killcam(attackerNum, pastTime, length, offsetTime, respawn, isReplay)
}
